package es.ejie.frmk.presentacion.sesiondatos.contexto.persistencia;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import org.apache.commons.collections.CollectionUtils;

import es.ejie.frmk.Q70Factoria;
import es.ejie.frmk.conectores.conectorJDBC.Q70ConectorJDBC;
import es.ejie.frmk.infraestructura.seguridad.Q70Constantes;
import es.ejie.frmk.infraestructura.traza.Q70TraceLevel;
import es.ejie.frmk.infraestructura.traza.Q70TrazaInterface;
import es.ejie.frmk.presentacion.sesiondatos.utilidades.Q70DatosDeSqlCampo;

/**
 * Implementa parte de la persistencia de contextos en base de datos, las clases hijas proporcionan el resto de la implementación.
 * <p>
 * La BD se indica en el fichero de configuración del contexto.
 * 
 * @version 1.0
 * Fecha: 20-ene-04
 */
public abstract class Q70PersistenciaBloqueandoRegistrosDesdeBD extends Q70PersistenciaDesdeBD {

	private static final String ID_COMPONENTE = "PERSISTENCIA_BLOQ_REG_DESDE_BD";
	
	public Q70PersistenciaBloqueandoRegistrosDesdeBD(Object datos) throws Q70PersistenciaMalInicializadaException {
		super(datos);
	}

	protected abstract void setAtributoAModificar(String atributo);
	
	/**
	 * Inserta o actualiza, segun corresponda, en el datasource asignado, el contexto de sesion usuario. 
	 */
	protected void doSaveSqlContextoEJIE() {
		boolean autocomitAnterior = true;
		Connection conn = null;
		PreparedStatement pstmt = null;
		ResultSet rdo = null;
		Q70TrazaInterface traza = Q70Factoria.getTraza();
		try {
			if (traza.isTraceActive()) {
				traza.trace(ID_COMPONENTE, Q70TraceLevel.DEBUG, "   >>> Iniciando la peticion de conexion a la BD.");
			}
			conn = Q70ConectorJDBC.getSingleton().getConnection(getDataSource());
			if (conn == null) {
				if (traza.isTraceActive()) {
					traza.trace(ID_COMPONENTE, Q70TraceLevel.DEBUG, "   <<< Conexion obtenida =NULL a la BD.");
				}
			}
			autocomitAnterior = conn.getAutoCommit();
			conn.setAutoCommit(false);
			
			if (traza.isTraceActive()) {
				traza.trace(ID_COMPONENTE, Q70TraceLevel.DEBUG, "   <<< Terminada la peticion de conexion a la BD.");
			}

			pstmt = conn.prepareStatement(getSelectForUpdateSentence(-1));
			doSelectForUpdateKey(pstmt);
					
			if (traza.isTraceActive()) {
				traza.trace(ID_COMPONENTE, Q70TraceLevel.DEBUG, "   >>> Iniciando la llamada a la BD.");
			}

			rdo = pstmt.executeQuery();

			List listaModificadosEnBD = new ArrayList(getContextoEJIEParent().getListaModificados().size());
			//Modificaciones de atributos que existen en BD
			while (rdo.next()){
				String atributoAModificarAux = rdo.getString(2);
				setAtributoAModificar(atributoAModificarAux);
				if (!getContextoEJIEParent().getListaModificados().contains(atributoAModificarAux)){
					continue;
				}
				if (atributoAModificarAux.equals(Q70Constantes.SEGURIDAD_USUARIO)){
					continue;
				}
				boolean esPersistente = true;
				if (getMapaSqlCampos().size() != 0)
				{
					esPersistente = !((Q70DatosDeSqlCampo) getMapaSqlCampos().get(atributoAModificarAux)).isNoPersistente();
				}
				if (esPersistente)
				{
					pstmt = conn.prepareStatement(getUpdateSentence(0));
					doGuardarDatos(pstmt, 0, true);
					pstmt.executeUpdate();
					listaModificadosEnBD.add(atributoAModificarAux);
				}
			}

			//Inserciones de atributos que no existen en BD
			Iterator it = CollectionUtils.subtract(getContextoEJIEParent().getListaModificados(),listaModificadosEnBD).iterator();
			while (it.hasNext()) {
				String atributoInsert = (String) it.next();
				setAtributoAModificar(atributoInsert);
				
				if (atributoInsert.equals(Q70Constantes.SEGURIDAD_USUARIO)){
					continue;
				}
				boolean esPersistente = true;
				if (getMapaSqlCampos().size() != 0)
				{
					esPersistente = !((Q70DatosDeSqlCampo) getMapaSqlCampos().get(atributoInsert)).isNoPersistente();
				}
				if (esPersistente)
				{
					pstmt = conn.prepareStatement(getInsertSentence(0));
					doGuardarDatos(pstmt, 0, false);
					pstmt.executeUpdate();
					listaModificadosEnBD.add(atributoInsert);
				}
			}
			
			conn.commit();
			if (traza.isTraceActive()) {
				traza.trace(ID_COMPONENTE, Q70TraceLevel.DEBUG, "   <<< Terminada la llamada a la BD.");
			}

		} catch (SQLException e) {
			try {
				if (conn != null){
					conn.rollback();
				}
			} catch (SQLException e1) {
			}
			if (traza.isTraceActive()) {
				traza.trace(ID_COMPONENTE, Q70TraceLevel.ERROR, "1.Error en tratamientoSQL(): " + e.getClass() + ":" + e.getMessage());
				traza.trace(ID_COMPONENTE, Q70TraceLevel.FATAL, "2.Error en tratamientoSQL(): linea cod.: " + getLineaCodigoGeremua(e));
				traza.trace(ID_COMPONENTE, Q70TraceLevel.ERROR, "3.Error en tratamientoSQL(): " + getUltimaSenteciaSqlEjecutada());
				traza.trace(ID_COMPONENTE, Q70TraceLevel.ERROR, "4.Error en tratamientoSQL():'" + getContextoEJIEParent().getTipoContexto()+"','"+getContextoEJIEParent().getIdContexto()+"'");
			}
		} catch (Throwable e) {
			try {
				if (conn != null){
					conn.rollback();
				}
			} catch (SQLException e1) {
			}
			if (traza.isTraceActive()) {
				traza.trace(ID_COMPONENTE, Q70TraceLevel.FATAL, "1.Fatal Error en tratamientoSQL(), Exception : " + e.getClass() + ":" + e.getMessage());
				traza.trace(ID_COMPONENTE, Q70TraceLevel.FATAL, "2.Fatal Error en tratamientoSQL(): linea cod.: " + getLineaCodigoGeremua(e));
				traza.trace(ID_COMPONENTE, Q70TraceLevel.FATAL, "3.Fatal Error en tratamientoSQL(), Ultima sql: " + getUltimaSenteciaSqlEjecutada());
				traza.trace(ID_COMPONENTE, Q70TraceLevel.FATAL, "4.Fatal Error en tratamientoSQL(), contexto  :'" + getContextoEJIEParent().getTipoContexto()+"','"+getContextoEJIEParent().getIdContexto()+"'");
			}
		} finally {
			setUltimaSenteciaSqlEjecutada("");
			try {
				if (rdo != null)
					rdo.close();
			} catch (SQLException e) {
			}
			try {
				if (pstmt != null)
					pstmt.close();
			} catch (SQLException e) {
			}
			try {
				if (conn != null){
					conn.setAutoCommit(autocomitAnterior);
					conn.close();
					if (traza.isTraceActive()) {
						traza.trace(ID_COMPONENTE, Q70TraceLevel.DEBUG, "   >>> Cerrada la conexion a la BD.");
					}
				}
			} catch (SQLException e) {
				if (traza.isTraceActive()) {
					traza.trace(ID_COMPONENTE, Q70TraceLevel.DEBUG, "   >>> Error al cerrar la conexion a la BD:" + e.getMessage());
				}
			}
		}
	}
	
	String doObtenerParametrosDeListaModificados() {
		String strParametrosNomnbres = "";
		Iterator it = getContextoEJIEParent().getListaModificados().iterator();
		while (it.hasNext()) {
			String element = (String) it.next();
			strParametrosNomnbres += "'" + element + "',";
		}
		if (!"".equals(strParametrosNomnbres)){
			strParametrosNomnbres = strParametrosNomnbres.substring(0,strParametrosNomnbres.length()-1);
		}
		return strParametrosNomnbres;
	}

	protected abstract String getSelectForUpdateSentence(int i);
	protected abstract void doSelectForUpdateKey(PreparedStatement pstmt) throws SQLException;
}
